/********************************************************************************
 *   dciBalance -- balance today plugin.                                        *
 *                                                                              * 
 *   Copyright (C) 2004-2007 dci (dev@cpp.in)                                   *
 *                                                                              *
 *   This program is free software; you can redistribute it and/or              *
 *   modify it under the terms of the GNU General Public License version 2      *
 *   as published by the Free Software Foundation.                              *
 *                                                                              *
 *   This program is distributed in the hope that it will be useful,            *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
 *   General Public License version 2 for more details.                         *
 *                                                                              *
 *   You should have received a copy of the GNU General Public License          *
 *   version 2 along with this library; if not, write to the Free Software      *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 ********************************************************************************
 */


#include "dciBalance.h"

HINSTANCE g_hInst  = NULL;
HWND      g_hPanel = NULL;
//
char      g_Status = STATUS_IDLE;
/* Setup */
DWORD   g_set_Textsize;
wchar_t g_set_OutStr[256];
wchar_t g_set_Channel[256];
DWORD   g_set_UpdateEvery;
DWORD   g_set_UpdateAfterDisconnect;

/* cache */
double g_cch_Value;
double g_cch_PrevValue;
double g_cch_PrevNEValue;
double g_cch_DayStartValue;
time_t g_cch_Time;

/* update */
time_t g_dUpdateTime = 0;
HANDLE g_hUpdater = NULL;

/* selection */
BOOL g_bSelected = FALSE;

/* graphics */
DWORD    g_dScreenDPI = 0;
HBITMAP  g_hIcons     = NULL;
HFONT    g_hMainFont  = NULL;
HFONT    g_hMiniFont  = NULL;


/* setup dlgproc */
BOOL CustomItemOptionsDlgProc ( HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam )
{
	if ( WM_INITDIALOG == Msg )
	{
		/* fullscreen, ok */
		SHINITDLGINFO l_ShIDI;
		l_ShIDI.dwMask = SHIDIM_FLAGS;
		l_ShIDI.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		l_ShIDI.hDlg = hDlg;
		SHInitDialog(&l_ShIDI);
		/* menubar */
		SHMENUBARINFO mbi = { sizeof ( SHMENUBARINFO ), hDlg, 0, IDR_SETTINGS_MENU, g_hInst, 0, 0, 0, 0 };
		SHCreateMenuBar ( &mbi );
		/* load settings to screen */
		SetDlgItemText ( hDlg, IDC_CHANNEL, g_set_Channel );
		SetDlgItemInt ( hDlg, IDC_FONTSIZE, g_set_Textsize, FALSE );
		SetDlgItemText ( hDlg, IDC_OUTSTR, g_set_OutStr );
		SetDlgItemInt ( hDlg, IDC_UPDATEEVERY, g_set_UpdateEvery / 60, FALSE );
		SetDlgItemInt ( hDlg, IDC_UPDATEAFTER, g_set_UpdateAfterDisconnect, FALSE );
		/* */
		return TRUE;
	}
	else if ( WM_SIZE == Msg )
	{
		RECT wrt, crt;
		GetClientRect ( hDlg, &wrt );
		/* position editboxes */
		GetWindowRect ( GetDlgItem ( hDlg, IDC_CHANNEL ), &crt );
		SetWindowPos ( GetDlgItem ( hDlg, IDC_CHANNEL ), HWND_TOP, 0, 0, wrt.right - crt.left - 10, crt.bottom - crt.top, SWP_NOMOVE );
		GetWindowRect ( GetDlgItem ( hDlg, IDC_FONTSIZE ), &crt );
		SetWindowPos ( GetDlgItem ( hDlg, IDC_FONTSIZE ), HWND_TOP, 0, 0, wrt.right - crt.left - 10, crt.bottom - crt.top, SWP_NOMOVE ); 
		GetWindowRect ( GetDlgItem ( hDlg, IDC_OUTSTR ), &crt );
		SetWindowPos ( GetDlgItem ( hDlg, IDC_OUTSTR ), HWND_TOP, 0, 0, wrt.right - crt.left - 10, crt.bottom - crt.top, SWP_NOMOVE ); 
		GetWindowRect ( GetDlgItem ( hDlg, IDC_UPDATE ), &crt );
		SetWindowPos ( GetDlgItem ( hDlg, IDC_UPDATE ), HWND_BOTTOM, 0, 0, wrt.right - crt.left - 10, crt.bottom - crt.top, SWP_NOMOVE ); 
		GetWindowRect ( GetDlgItem ( hDlg, IDC_UPDATEEVERY ), &crt );
		SetWindowPos ( GetDlgItem ( hDlg, IDC_UPDATEEVERY ), HWND_TOP, 0, 0, wrt.right - crt.left - 20, crt.bottom - crt.top, SWP_NOMOVE ); 
		GetWindowRect ( GetDlgItem ( hDlg, IDC_UPDATEAFTER ), &crt );
		SetWindowPos ( GetDlgItem ( hDlg, IDC_UPDATEAFTER ), HWND_TOP, 0, 0, wrt.right - crt.left - 20, crt.bottom - crt.top, SWP_NOMOVE ); 
		/* position (c) */
		GetClientRect ( GetDlgItem ( hDlg, IDC_COPYRIGHT ), &crt );
		SetWindowPos ( GetDlgItem ( hDlg, IDC_COPYRIGHT ), HWND_TOP, wrt.right - crt.right - 6, wrt.bottom - crt.bottom - 6, crt.right, crt.bottom, 0 ); 
	}
	else if ( WM_DESTROY == Msg )
	{
		EndDialog ( hDlg, 0 );
		return TRUE;
	}
	else if ( Msg == WM_COMMAND )
	{
		int cID = LOWORD ( wParam );
		if ( IDC_OUTSTR_HINT == cID )
		{
			MessageBox ( hDlg, L"| = \n%v =  \n%cp = .  \n%cn = . \n%cd = .   \n%ud =  .\n%ut =  .", L"dciBalance", MB_TOPMOST );
			return TRUE;
		}
		else if ( IDOK == cID )
		{
			/* load settings from dialog */
			GetDlgItemText ( hDlg, IDC_CHANNEL, g_set_Channel, sizeof ( g_set_Channel ) / sizeof ( * g_set_Channel ) );
			g_set_Textsize = GetDlgItemInt ( hDlg, IDC_FONTSIZE, NULL, FALSE );
			GetDlgItemText ( hDlg, IDC_OUTSTR, g_set_OutStr, sizeof ( g_set_OutStr ) / sizeof ( * g_set_OutStr ) );
			g_set_UpdateEvery = GetDlgItemInt ( hDlg, IDC_UPDATEEVERY, NULL, FALSE ) * 60;
			g_set_UpdateAfterDisconnect = GetDlgItemInt ( hDlg, IDC_UPDATEAFTER, NULL, FALSE );
			/* */
			SaveSettings ( );
			/* */
			EndDialog ( hDlg, 1 );
			return TRUE;
		}
		else if ( IDCANCEL == cID )
		{
			EndDialog ( hDlg, 0 );
			return TRUE;
		}
	}
	return FALSE;
}


/* updater */
DWORD UpdateThread ( LPVOID lpParam )
{
	/* set 'updating' status */
	g_Status = STATUS_UPDATING;
	InvalidateRect ( g_hPanel, NULL, TRUE );
	UpdateWindow ( g_hPanel );
	/* request */
	double newbalance;
	if ( ic_RIL_Request_Balance ( &newbalance, g_set_Channel ) )
	{
		/* new value != last */
		if ( newbalance != g_cch_Value )
		{
			g_cch_PrevNEValue = g_cch_Value;
		}
		/* this is first time, set day start value */
		if ( 0 == g_cch_Time )
		{
			g_cch_DayStartValue = newbalance;
		}
		/* */
		g_cch_PrevValue = g_cch_Value;
		g_cch_Value = newbalance;
		g_cch_Time = get_time ( );
		/* */
		SaveSettings ( );
		g_Status = STATUS_UPDATED_OK;
	}
	else
	{
		g_Status = STATUS_UPDATED_ERR;
	}
	/* let user watch status */
	InvalidateRect ( g_hPanel, NULL, TRUE );
	UpdateWindow ( g_hPanel );
	Sleep ( 1000 );
	/* set 'idle' status */
	g_Status = g_cch_Time ? STATUS_IDLE : STATUS_IDLE_NOTACTUAL;
	InvalidateRect ( g_hPanel, NULL, TRUE );
	UpdateWindow ( g_hPanel );
	/* */
	CloseHandle ( g_hUpdater );
	g_hUpdater = 0;
	return 0;
}

/* disconnect handler */
void HandleDisconnect ( )
{
	/* set time of next update */
	if ( g_set_UpdateAfterDisconnect )
	{
		time_t disupdate = get_time ( ) + g_set_UpdateAfterDisconnect;
		g_dUpdateTime = g_dUpdateTime ? min ( g_dUpdateTime, disupdate ) : disupdate;
	}
}


/* widechar replace */
int wcsreplace ( wchar_t * string, const wchar_t * find, const wchar_t * replace )
{
	int ret  = 0;
	int flen = wcslen ( find );
	int rlen = wcslen ( replace );
	wchar_t * findchar = string;
	while ( findchar = wcsstr ( findchar, find ) )
	{
		memmove ( findchar + rlen, findchar + flen, ( wcslen ( findchar ) + 1 ) * sizeof ( wchar_t ) );
		memcpy  ( findchar, replace, rlen * sizeof ( wchar_t ) );
		++ret;
	}
	return ret;
}


/* panel wndproc */
static LRESULT CALLBACK WndProc ( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam )
{
	if ( WM_CREATE == Msg )
	{
		/* init RIL */
		ic_RIL_Init ( 1, NULL, HandleDisconnect );
		/* aquire screen dpi */
		HDC ScreenDC = GetDC ( NULL );
		g_dScreenDPI = GetDeviceCaps ( ScreenDC, LOGPIXELSX );
		ReleaseDC ( NULL, ScreenDC );
		/* load icons */
		g_hIcons = SHLoadImageResource ( g_hInst, ( g_dScreenDPI == 192 ) ?  IDG_ICON192 : IDG_ICON96 );
		/* */
		g_Status = g_cch_Time ? STATUS_IDLE : STATUS_IDLE_NOTACTUAL;
		g_dUpdateTime = g_set_UpdateEvery ? ( get_time ( ) + g_set_UpdateEvery ) : 0;
		return 0;
	}
	else if ( WM_SIZE == Msg )
	{
		return 0;
	}
	else if ( WM_DESTROY == Msg )
	{
		/* free icons */
		DeleteObject ( g_hIcons );
		/* free fonts */
		if ( g_hMainFont )
		{
			DeleteObject ( g_hMainFont );
			g_hMainFont = NULL;
		}
		if ( g_hMiniFont )
		{
			DeleteObject ( g_hMiniFont );
			g_hMiniFont = NULL;
		}
		/* free ril */
		ic_RIL_Free ( );
		/* */
		return 0;
	}
	else if ( WM_LBUTTONDOWN == Msg )
	{
		int cx = LOWORD ( lParam );
		int cy = HIWORD ( lParam );
		/* */
		RECT rt;
		GetClientRect ( hWnd, &rt );
		/* */
		if ( cx <= rt.bottom ) /* icon tapped */
		{
			SHRGINFO l_SI = { sizeof ( SHRGINFO ), hWnd, { cx, cy }, SHRG_RETURNCMD };
			if ( SHRecognizeGesture ( &l_SI ) == GN_CONTEXTMENU )
			{ /* long tap, show settings */
				DialogBoxParam ( g_hInst, MAKEINTRESOURCE( IDD_SETTINGS ), NULL, CustomItemOptionsDlgProc, 0 );
				if ( g_hMainFont )
				{
					DeleteObject ( g_hMainFont );
					g_hMainFont = NULL;
				}
				if ( g_hMiniFont )
				{
					DeleteObject ( g_hMiniFont );
					g_hMiniFont = NULL;
				}
				g_dUpdateTime = g_set_UpdateEvery ? ( get_time ( ) + g_set_UpdateEvery ) : 0;
			}
			else
			{ /* short tap, update */
				SendMessage ( hWnd, WM_TODAYCUSTOM_ACTION, 0, 0 );
			}
		}
		else
		{ /* balance loaded? */
			if ( g_cch_Time )
			{ /* copy to clipboard */
				wchar_t * l_ClipboardData = ( wchar_t * ) LocalAlloc ( LPTR, 128 );
				swprintf ( l_ClipboardData, L"%.02f", g_cch_Value );
				OpenClipboard ( 0 );
				EmptyClipboard ( );
				SetClipboardData ( CF_UNICODETEXT, l_ClipboardData );
				CloseClipboard();
			}
			else
			{ /* no balance, update */
				SendMessage ( hWnd, WM_TODAYCUSTOM_ACTION, 0, 0 );
			}
		}
		return 0;
	}
	else if ( WM_ERASEBKGND == Msg )
	{
		if ( g_bSelected )
		{
			HBRUSH hbr = CreateSolidBrush ( ( COLORREF ) SendMessage ( GetParent ( hWnd ), TODAYM_GETCOLOR, TODAYCOLOR_HIGHLIGHT, 0 ) );
			RECT rt;
			GetClientRect ( hWnd, &rt );
			FillRect ( ( HDC ) wParam, & rt, hbr );
			DeleteObject ( hbr );
		}
		else
		{
			TODAYDRAWWATERMARKINFO l_TDWI;
			l_TDWI.hdc = ( HDC ) wParam;
			GetClientRect ( hWnd, &l_TDWI.rc );
			l_TDWI.hwnd = hWnd;
			SendMessage ( GetParent ( hWnd ), TODAYM_DRAWWATERMARK, 0, ( LPARAM ) &l_TDWI );
		}
		return 0;
	}
	else if ( WM_PAINT == Msg )
	{
		PAINTSTRUCT l_PS;
		BeginPaint ( hWnd, &l_PS );
		SetBkMode ( l_PS.hdc, TRANSPARENT );
		/* get window sizes */
		RECT wrt;
		GetClientRect ( hWnd, &wrt );
		/* check for fonts */
		LOGFONT lfFont;
		if ( NULL == g_hMainFont )
		{
			memset ( &lfFont, 0, sizeof ( LOGFONT ) );
			wcscpy ( lfFont.lfFaceName, L"Tahoma" );
			lfFont.lfPitchAndFamily = DEFAULT_PITCH | FF_ROMAN;
			lfFont.lfHeight = g_set_Textsize * ( g_dScreenDPI / 96 );
			lfFont.lfWeight = FW_BOLD;
			lfFont.lfCharSet = RUSSIAN_CHARSET;
			g_hMainFont = CreateFontIndirect ( &lfFont );
		}
		if ( NULL == g_hMiniFont )
		{
			memset ( &lfFont, 0, sizeof ( LOGFONT ) );
			wcscpy ( lfFont.lfFaceName, L"Tahoma" );
			lfFont.lfPitchAndFamily = DEFAULT_PITCH | FF_ROMAN;
			lfFont.lfHeight = ( ( g_set_Textsize * ( g_dScreenDPI / 96 ) ) * 4 ) / 5;
			lfFont.lfWeight = FW_NORMAL;
			lfFont.lfCharSet = RUSSIAN_CHARSET;
			g_hMiniFont = CreateFontIndirect ( &lfFont );
		}
		/* draw icon */
		BITMAP bm;
		GetObject ( g_hIcons, sizeof ( BITMAP ), &bm );
		HDC cdc = CreateCompatibleDC ( l_PS.hdc );
		g_hIcons = ( HBITMAP ) SelectObject ( cdc, g_hIcons );
		TransparentBlt ( l_PS.hdc, bm.bmHeight / 5, ( wrt.bottom - bm.bmHeight ) / 2, bm.bmHeight, bm.bmHeight, cdc, g_Status * bm.bmHeight, 0, bm.bmHeight, bm.bmHeight, TRANSPARENT_BACK );
		g_hIcons = ( HBITMAP ) SelectObject ( cdc, g_hIcons );
		DeleteDC ( cdc );
		/* draw text */
		// set color
		SetTextColor ( l_PS.hdc, ( COLORREF ) SendMessage ( GetParent ( hWnd ), TODAYM_GETCOLOR, g_bSelected ? TODAYCOLOR_HIGHLIGHTEDTEXT : TODAYCOLOR_TEXT, 0 ) );
		// set main font
		HFONT hOldFont = ( HFONT ) SelectObject ( l_PS.hdc, g_hMainFont );
		/* out */
		if ( g_cch_Time )
		{
			SYSTEMTIME st;
			wchar_t outstr[1024];
			time_to_st ( g_cch_Time, &st );
			wcscpy ( outstr, g_set_OutStr );
			/* set params */
			wchar_t pbuf[64];
			//value
			swprintf ( pbuf, L"%.02f", g_cch_Value );
			wcsreplace ( outstr, L"%v", pbuf );
			//changed from prev
			swprintf ( pbuf, L"%.02f", g_cch_Value - g_cch_PrevValue );
			wcsreplace ( outstr, L"%cp", pbuf );
			//changed from last not equal
			swprintf ( pbuf, L"%.02f", g_cch_Value - g_cch_PrevNEValue );
			wcsreplace ( outstr, L"%cn", pbuf );
			//changed from day begin
			swprintf ( pbuf, L"%.02f", g_cch_Value - g_cch_DayStartValue );
			wcsreplace ( outstr, L"%cd", pbuf );
			//date
			swprintf ( pbuf, L"%02d/%02d", st.wDay, st.wMonth );
			wcsreplace ( outstr, L"%ud", pbuf );
			//time
			swprintf ( pbuf, L"%d:%02d", st.wHour, st.wMinute );
			wcsreplace ( outstr, L"%ut", pbuf );
			/* try to find sep */
			wchar_t * sep = wcschr ( outstr, '|' );
			if ( sep ) * sep = 0;
			/* print out first/main part */
			ExtTextOut ( l_PS.hdc, ( int ) ( bm.bmHeight * 1.75 ), 2, 0, NULL, outstr, wcslen ( outstr ), NULL );
			/* second part exists? */
			if ( sep )
			{
				++sep;
				/* select minifont */
				HFONT hOldFont = ( HFONT ) SelectObject ( l_PS.hdc, g_hMiniFont );
				/* calc sizes */
				SIZE extent;
				GetTextExtentPoint ( l_PS.hdc, sep, wcslen ( sep ), &extent );
				ExtTextOut ( l_PS.hdc, wrt.right - 6 - extent.cx, wrt.bottom - 2 - extent.cy, 0, NULL, sep, wcslen ( sep ), NULL );
				/* deselect minifont */
				SelectObject ( l_PS.hdc, hOldFont );
			}
		}
		else
		{
			wchar_t * msg = L"  ";
			ExtTextOut ( l_PS.hdc, ( int ) ( bm.bmHeight * 1.75 ), 2, 0, NULL, msg, wcslen ( msg ), NULL );
		}
		/* deselect font */
		SelectObject ( l_PS.hdc, hOldFont );
		/* */
		EndPaint ( hWnd, &l_PS );
		return 0;
	}
	else if ( WM_TODAYCUSTOM_RECEIVEDSELECTION == Msg )
	{
		g_bSelected = TRUE;
		return TRUE;
	}
	else if ( WM_TODAYCUSTOM_LOSTSELECTION == Msg )
	{
		g_bSelected = FALSE;
		return TRUE;
	}
	else if ( WM_TODAYCUSTOM_USERNAVIGATION == Msg )
	{
		//return TRUE;  // stay in this plug-in
		return FALSE; // go to the next plug-in
	}
	else if ( WM_TODAYCUSTOM_ACTION == Msg )
	{
		/* update */
		if ( g_hUpdater == NULL )
		{
			g_hUpdater = CreateThread ( NULL, 0, UpdateThread, NULL, 0, NULL );
		}
		/* */
		return 0;
	}
	else if ( WM_TODAYCUSTOM_QUERYREFRESHCACHE == Msg )
	{
		time_t now = get_time ( );

		/* check update timer */
		if ( g_dUpdateTime > 0 )
		{
			if ( now >= g_dUpdateTime )
			{
				/* is it came just few seconds ago? */
				if ( ( now - g_dUpdateTime ) < 6 )
				{ /* update and set time to next regular update */
					SendMessage ( hWnd, WM_TODAYCUSTOM_ACTION, 0, 0 );
					g_dUpdateTime = g_set_UpdateEvery ? ( now + g_set_UpdateEvery ) : 0;
				}
				else
				{ /* probably device was asleep. delay update to few seconds to let radio init */
					g_dUpdateTime = now + 8;
				}
			}
		}

		/* check date */
		static time_t prevchk = 0;
		/* if first time -- set to update time */
		if ( 0 == prevchk ) prevchk = g_cch_Time;
		/* compare */
		SYSTEMTIME cst, ust;
		time_to_st ( now, &cst );
		time_to_st ( prevchk, &ust );
		/* day changed */
		if ( ( cst.wYear != ust.wYear ) || ( cst.wMonth != ust.wMonth ) || ( cst.wDay != ust.wDay ) )
		{ /* set day start to last retrieved and redraw */
			g_cch_DayStartValue = g_cch_Value;
			InvalidateRect ( hWnd, NULL, TRUE );
		}
		/* */
		prevchk = now;

		/* calc font size */
		DWORD mSize = g_set_Textsize * ( g_dScreenDPI / 96 );
		/* check if panel height corresponds to font size */
		if ( ( mSize + 4 ) != ( ( TODAYLISTITEM * ) wParam )->cyp )
		{
			( ( TODAYLISTITEM * ) wParam )->cyp = mSize + 4;
			return TRUE;
		}
		return FALSE;			
	}
	else
	{
		return DefWindowProc(hWnd, Msg, wParam, lParam);
	}
}

HWND InitializeCustomItem ( TODAYLISTITEM * ptli, HWND hwndParent )
{
	g_hPanel = CreateWindow ( PANEL_WND_STRING, PANEL_WND_STRING, WS_VISIBLE | WS_CHILD, CW_DEFAULT, CW_DEFAULT, 0, 0, hwndParent, 0, g_hInst, 0 );
	return g_hPanel;
}

void SaveSettings ( )
{
	HKEY hKey;
	DWORD dummy;
	if ( ERROR_SUCCESS == RegCreateKeyEx ( HKEY_CURRENT_USER, L"\\SOFTWARE\\dci\\dciBalance", 0, NULL, 0, NULL, NULL, &hKey, &dummy ) )
	{
		RegSetValueEx ( hKey, L"textsize", NULL, REG_DWORD, ( BYTE * ) &g_set_Textsize, sizeof ( g_set_Textsize ) );
		RegSetValueEx ( hKey, L"outstr", NULL, REG_SZ, ( BYTE * ) g_set_OutStr, wcslen ( g_set_OutStr ) * sizeof ( wchar_t ) );
		RegSetValueEx ( hKey, L"channel", NULL, REG_SZ, ( BYTE * ) g_set_Channel, wcslen ( g_set_Channel ) * sizeof ( wchar_t ) );
		RegSetValueEx ( hKey, L"uevery", NULL, REG_DWORD, ( BYTE * ) &g_set_UpdateEvery, sizeof ( g_set_UpdateEvery ) );
		RegSetValueEx ( hKey, L"uafter", NULL, REG_DWORD, ( BYTE * ) &g_set_UpdateAfterDisconnect, sizeof ( g_set_UpdateAfterDisconnect ) );
		RegSetValueEx ( hKey, L"cchvalue", NULL, REG_BINARY, ( BYTE * ) &g_cch_Value, sizeof ( g_cch_Value ) );
		RegSetValueEx ( hKey, L"cchpvalue", NULL, REG_BINARY, ( BYTE * ) &g_cch_PrevValue, sizeof ( g_cch_PrevValue ) );
		RegSetValueEx ( hKey, L"cchpnevalue", NULL, REG_BINARY, ( BYTE * ) &g_cch_PrevNEValue, sizeof ( g_cch_PrevNEValue ) );
		RegSetValueEx ( hKey, L"cchdsvalue", NULL, REG_BINARY, ( BYTE * ) &g_cch_DayStartValue, sizeof ( g_cch_DayStartValue ) );
		RegSetValueEx ( hKey, L"cchtime", NULL, REG_BINARY, ( BYTE * ) &g_cch_Time, sizeof ( g_cch_Time ) );
		/* */
		RegCloseKey ( hKey );
	}
}

BOOL APIENTRY DllMain(HANDLE hModule, DWORD Reason, LPVOID lpReserved)
{
	if ( DLL_PROCESS_ATTACH == Reason )
	{
		/* basic initialization */
		g_hInst = ( HINSTANCE ) hModule;
		InitCommonControls ( );
		/* load settings */
		HKEY hKey;
		DWORD dummy, size;
		if ( ERROR_SUCCESS == RegCreateKeyEx ( HKEY_CURRENT_USER, L"\\SOFTWARE\\dci\\dciBalance", 0, NULL, 0, NULL, NULL, &hKey, &dummy ) )
		{
			g_set_Textsize = 0;
			size = sizeof ( g_set_Textsize );
			RegQueryValueEx ( hKey, L"textsize", NULL, &dummy, ( BYTE * ) &g_set_Textsize, &size );
			if ( g_set_Textsize == 0 ) g_set_Textsize = 14;
			g_set_OutStr[0] = 0;
			size = sizeof ( g_set_OutStr );
			RegQueryValueEx ( hKey, L"outstr", NULL, &dummy, ( BYTE * ) g_set_OutStr, &size );
			if ( g_set_OutStr[0] == 0 ) wcscpy ( g_set_OutStr, L": %v.|%ut %ud" );
			g_set_Channel[0] = 0;
			size = sizeof ( g_set_Channel );
			RegQueryValueEx ( hKey, L"channel", NULL, &dummy, ( BYTE * ) g_set_Channel, &size );
			g_set_UpdateEvery = 0;
			size = sizeof ( g_set_UpdateEvery );
			RegQueryValueEx ( hKey, L"uevery", NULL, &dummy, ( BYTE * ) &g_set_UpdateEvery, &size );
			g_set_UpdateAfterDisconnect = 0;
			size = sizeof ( g_set_UpdateAfterDisconnect );
			RegQueryValueEx ( hKey, L"uafter", NULL, &dummy, ( BYTE * ) &g_set_UpdateAfterDisconnect, &size );
			/* */
			g_cch_Value = 0.0;
			size = sizeof ( g_cch_Value );
			RegQueryValueEx ( hKey, L"cchvalue", NULL, &dummy, ( BYTE * ) &g_cch_Value, &size );
			g_cch_PrevValue = 0.0;
			size = sizeof ( g_cch_PrevValue );
			RegQueryValueEx ( hKey, L"cchpvalue", NULL, &dummy, ( BYTE * ) &g_cch_PrevValue, &size );
			g_cch_PrevNEValue = 0.0;
			size = sizeof ( g_cch_PrevNEValue );
			RegQueryValueEx ( hKey, L"cchpnevalue", NULL, &dummy, ( BYTE * ) &g_cch_PrevNEValue, &size );
			g_cch_DayStartValue = 0.0;
			size = sizeof ( g_cch_DayStartValue );
			RegQueryValueEx ( hKey, L"cchdsvalue", NULL, &dummy, ( BYTE * ) &g_cch_DayStartValue, &size );
			g_cch_Time = 0;
			size = sizeof ( g_cch_Time );
			RegQueryValueEx ( hKey, L"cchtime", NULL, &dummy, ( BYTE * ) &g_cch_Time, &size );
			/* */
			RegCloseKey ( hKey );
		}
		/* register panel class */
		WNDCLASS l_WC = { CS_HREDRAW | CS_VREDRAW, ( WNDPROC ) WndProc, 0, 0, g_hInst, NULL, 0, ( HBRUSH ) GetStockObject ( WHITE_BRUSH ), 0, PANEL_WND_STRING };
		RegisterClass ( &l_WC );
	}
	else if ( DLL_PROCESS_DETACH == Reason )
	{
		/* unregister class */
		UnregisterClass ( PANEL_WND_STRING, g_hInst );
		/* free settings */
		g_set_Textsize = 0;
		g_set_OutStr[0] = 0;
		g_set_Channel[0] = 0;
		g_set_UpdateEvery = 0;
		g_set_UpdateAfterDisconnect = 0;
		/* */
		g_cch_Value = 0.0;
		g_cch_PrevValue = 0.0;
		g_cch_PrevNEValue = 0.0;
		g_cch_DayStartValue = 0.0;
		g_cch_Time = 0;
		/* */
		g_hInst = NULL;
	}
	return TRUE;
}
