/********************************************************************************
 *   dciBalance -- balance today plugin.                                        *
 *                                                                              * 
 *   Copyright (C) 2004-2007 dci (dev@cpp.in)                                   *
 *                                                                              *
 *   This program is free software; you can redistribute it and/or              *
 *   modify it under the terms of the GNU General Public License version 2      *
 *   as published by the Free Software Foundation.                              *
 *                                                                              *
 *   This program is distributed in the hope that it will be useful,            *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
 *   General Public License version 2 for more details.                         *
 *                                                                              *
 *   You should have received a copy of the GNU General Public License          *
 *   version 2 along with this library; if not, write to the Free Software      *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 ********************************************************************************
 */


#include <windows.h>
//
#include <pkfuncs.h>
#include <psyscall.h>
#include <kernel.h>
//
#include <ril.h>
//
extern "C"
{
	HLOCAL RemoteHeapAlloc ( HPROCESS, HANDLE, DWORD, DWORD );
	VOID   RemoteHeapFree  ( HPROCESS, HANDLE, HLOCAL );
	DWORD  GetEventData    ( HANDLE );
	BOOL   SetEventData    ( HANDLE, DWORD );
};

/* UNIFIED PATCHER */
DWORD ic_PatchProcImports ( HANDLE hProc, DWORD dFind, DWORD dReplace )
{
	DWORD ret = 0;
	/* GODMODE ON */
	BOOL  bOldKMode = SetKMode ( TRUE );
	DWORD dOldPerms = SetProcPermissions ( 0xFFFFFFFF );
	/* get process ptr prom handle */
	HDATA * hProcHD = ( HDATA * ) ( 0x80000000 | ( ( DWORD ) hProc & HANDLE_ADDRESS_MASK ) );
	PROCESS * prc = ( PROCESS * ) hProcHD->pvObj;
	/* get imports sections */
	struct ImpHdr * blockptr, * blockstart;
	blockstart = ( struct ImpHdr * ) MapPtrProc ( prc->e32.e32_vbase + prc->e32.e32_unit[IMP].rva, prc );
	/* iterate thru imports sections */
	for ( blockptr = blockstart; blockptr->imp_lookup; ++blockptr )
	{
		DWORD dOldProtect, tmp;
		/* get vectors ptr */
		DWORD * vectors = ( DWORD * ) MapPtrProc ( prc->e32.e32_vbase + blockptr->imp_address, prc );
		/* count vectors */
		DWORD * vptr = vectors;
		while ( * vptr ) ++vptr;
		DWORD vcnt = ( vptr - vectors );
		/* try to unlock imports section memory */
		if ( VirtualProtect ( vectors, vcnt * sizeof ( DWORD ), PAGE_EXECUTE_READWRITE, &dOldProtect ) )
		{
			/* find&replace */
			for ( UINT i = 0; i < vcnt; ++i )
			{
				if ( vectors[i] == dFind )
				{
					vectors[i] = dReplace;
					++ret;
				}
			}
			/* lock back */
			VirtualProtect ( vectors, vcnt * sizeof ( DWORD ), dOldProtect, &tmp );
		}
	}
	/* GODMODE OFF */
	SetProcPermissions ( dOldPerms );
	SetKMode ( bOldKMode );
	/* */
	return ret;
}

/* CPROG BLOCKER */
DWORD ppSHBoxEx = 0;
DWORD ppSHPowerState = 0;
DWORD ppPlayEventSound = 0;
DWORD ppStub1 = 0;
DWORD ppStub2 = 0;
DWORD ppStub3 = 0;

void ic_cprog_lock ( )
{
	PROCESS * prc = NULL;
	/* GODMODE ON */
	BOOL  bOldKMode = SetKMode ( TRUE );
	DWORD dOldPerms = SetProcPermissions ( 0xFFFFFFFF );
	/* find cprog */
	for ( int i = 0; i < 32; ++i )
	{
		PROCESS * tprc = ( ( PROCESS * ) KData.aInfo[KINX_PROCARRAY] ) + i;
		if ( tprc->dwVMBase && ( 0 == _wcsicmp ( tprc->lpszProcName, L"cprog.exe" ) ) )
		{
			prc = tprc;
		}
	}
	/* found? */
	if ( prc )
	{
		/* found imports to patch */
		if ( 0 == ppSHBoxEx )
		{
			HMODULE ay = LoadLibrary ( L"AYGSHELL.DLL" );
			ppSHBoxEx = ( DWORD ) GetProcAddress ( ay, L"SHBoxEx" );
			ppSHPowerState = ( DWORD ) GetProcAddress ( ay, ( wchar_t * ) 1000 );
			FreeLibrary ( ay );
		}
		/* */
		if ( 0 == ppPlayEventSound )
		{
			HMODULE ov = LoadLibrary ( L"OSSVCS.DLL" );
			ppPlayEventSound = ( DWORD ) GetProcAddress ( ov, L"PlayEventSound" );
			FreeLibrary ( ov );
		}
		/* create stubs */
		DWORD tmp;
		ppStub1 = ( DWORD ) RemoteHeapAlloc ( prc->hProc, NULL, LMEM_FIXED, 36 );
		VirtualProtect ( ( void * ) ppStub1, 36, PAGE_EXECUTE_READWRITE, &tmp );
		ppStub2 = ppStub1 + 12;
		ppStub3 = ppStub2 + 12;
		( ( DWORD * ) ppStub1 ) [0] = ( ( DWORD * ) ppStub2 ) [0] = ( ( DWORD * ) ppStub3 ) [0] = 0xE59F0000;
		( ( DWORD * ) ppStub1 ) [1] = ( ( DWORD * ) ppStub2 ) [1] = ( ( DWORD * ) ppStub3 ) [1] = 0xE12FFF1E;
		( ( DWORD * ) ppStub1 ) [2] = ( ( DWORD * ) ppStub2 ) [2] = ( ( DWORD * ) ppStub3 ) [2] = 0x80004005;
		/* patch imports */
		ic_PatchProcImports ( prc->hProc, ppSHBoxEx, ppStub1 );
		ic_PatchProcImports ( prc->hProc, ppSHPowerState, ppStub2 );
		ic_PatchProcImports ( prc->hProc, ppPlayEventSound, ppStub3 );
	}
	/* GODMODE OFF */
	SetProcPermissions ( dOldPerms );
	SetKMode ( bOldKMode );
}

void ic_cprog_unlock ( )
{
	PROCESS * prc = NULL;
	/* GODMODE ON */
	BOOL  bOldKMode = SetKMode ( TRUE );
	DWORD dOldPerms = SetProcPermissions ( 0xFFFFFFFF );
	/* find cprog */
	for ( int i = 0; i < 32; ++i )
	{
		PROCESS * tprc = ( ( PROCESS * ) KData.aInfo[KINX_PROCARRAY] ) + i;
		if ( tprc->dwVMBase && ( 0 == _wcsicmp ( tprc->lpszProcName, L"cprog.exe" ) ) )
		{
			prc = tprc;
		}
	}
	/* found? */
	if ( prc )
	{
		/* patch back */
		ic_PatchProcImports ( prc->hProc, ppStub1, ppSHBoxEx );
		ic_PatchProcImports ( prc->hProc, ppStub2, ppSHPowerState );
		ic_PatchProcImports ( prc->hProc, ppStub3, ppPlayEventSound );
		/* destroy stubs */
		RemoteHeapFree ( prc->hProc, NULL, ( void * ) ppStub1 );
	}
	/* GODMODE OFF */
	SetProcPermissions ( dOldPerms );
	SetKMode ( bOldKMode );
}


/* RIL */
void ( * g_pOnConnect ) ( );
void ( * g_pOnDisconnect ) ( );
HMODULE g_hRilDLL = NULL;
HANDLE  g_hRil = NULL;
HRESULT g_hCommand = NULL;
HANDLE  g_hResultEvent = NULL;

void ic_RIL_NotifyCallback ( DWORD dwCode, const void * lpData, DWORD cbData, DWORD dwParam )
{
	/* we are waiting and got ssd */
	if ( g_hCommand && ( dwCode == RIL_NOTIFY_SUPSERVICEDATA ) )
	{
		/* set result */
		void * mem = malloc ( cbData );
		memcpy ( mem, lpData, cbData );
		SetEventData ( g_hResultEvent, ( DWORD ) mem );
		SetEvent ( g_hResultEvent );
		/* we are no longer waiting */
		g_hCommand = NULL;

	}
	/* we are just listening and we got connect/disconnect */
	if ( ( dwCode == RIL_NOTIFY_CONNECT ) && g_pOnConnect )
	{
		g_pOnConnect ( );
	}
	else if ( ( dwCode == RIL_NOTIFY_DISCONNECT ) && g_pOnDisconnect )
	{
		g_pOnDisconnect ( );
	}
}

void ic_RIL_ResultCallback ( DWORD dwCode, HRESULT hrCmdID, const void * lpData, DWORD cbData, DWORD dwParam )
{
	if ( ( ( dwCode & RIL_NCLASS_ALL ) == ( RIL_NCLASS_FUNCRESULT & RIL_NCLASS_ALL ) ) && ( hrCmdID == g_hCommand ) )
	{ /* this is result of our call */
		if ( dwCode == RIL_RESULT_OK )
		{ /* no error */
			if ( cbData )
			{
				/* set result */
				void * mem = malloc ( cbData );
				memcpy ( mem, lpData, cbData );
				SetEventData ( g_hResultEvent, ( DWORD ) mem );
				SetEvent ( g_hResultEvent );
				/* we are no longer waiting */
				g_hCommand = NULL;

			}
			/* wait for notify in some cases */
		}
		else
		{ /* abort */
			SetEventData ( g_hResultEvent, 0 );
			SetEvent ( g_hResultEvent );
		}
	}
}

bool ic_RIL_Init ( unsigned char rilnum, void ( * pOnConnect ) ( ) = NULL, void ( * pOnDisconnect ) ( ) = NULL )
{
	g_pOnConnect = pOnConnect;
	g_pOnDisconnect = pOnDisconnect;
	/* */
	g_hRilDLL = LoadLibrary ( L"ril.dll" );
	if ( g_hRilDLL )
	{
		/* try to init */
		FARPROC call = GetProcAddress ( g_hRilDLL, L"RIL_Initialize" );
		if ( call && SUCCEEDED ( ( ( HRESULT ( * ) ( DWORD, void *, void *, DWORD, DWORD, HANDLE * ) ) call ) ( rilnum, ic_RIL_ResultCallback, ic_RIL_NotifyCallback, 0xFFFFFFFF, 0, &g_hRil ) ) )
		{
			g_hResultEvent = CreateEvent ( NULL, 0, 0, L"ResultEvent" );
			SetEventData ( g_hResultEvent, 0 );
			return 1;
		}
		FreeLibrary ( g_hRilDLL );
		g_hRil = NULL;
		g_hRilDLL = NULL;
	}
	return 0;
}

bool ic_RIL_NCode ( wchar_t * reply, size_t max_reply )
{
	bool ret = 0;
	if ( g_hRil && ( g_hCommand == NULL ) )
	{
		/* previous result pending? */
		wchar_t * oldresult = ( wchar_t * ) GetEventData ( g_hResultEvent );
		if ( oldresult )
		{
			free ( oldresult );
		}
		SetEventData ( g_hResultEvent, 0 );
		ResetEvent ( g_hResultEvent );
		/* exec */
		FARPROC call = GetProcAddress ( g_hRilDLL, L"RIL_GetCurrentOperator" );
		g_hCommand = ( ( HRESULT ( * ) ( HANDLE hRil, DWORD dwFormat ) ) call ) ( g_hRil, RIL_OPFORMAT_LONG | RIL_OPFORMAT_SHORT | RIL_OPFORMAT_NUM );
		if ( SUCCEEDED ( g_hCommand ) )
		{
			/* wait for new result */
			if ( WaitForSingleObject ( g_hResultEvent, 1000 ) == WAIT_OBJECT_0 )
			{
				RILOPERATORNAMES * result = ( RILOPERATORNAMES * ) GetEventData ( g_hResultEvent );
				if ( result )
				{
					ret = 1;
					/* */
					for ( size_t i = 0; i < min ( strlen ( result->szNumName ) + 1, max_reply ); ++i ) reply[i] = result->szNumName[i];
					reply[max_reply - 1] = 0;
					/* */
					free ( result );
					SetEventData ( g_hResultEvent, 0 );
				}
			}
		}
		g_hCommand = NULL;
	}
	/* */
	return ret;
}

bool ic_RIL_USSD ( wchar_t * request, DWORD timeout, wchar_t * reply, size_t max_reply )
{
	bool ret = 0;
	if ( g_hRil && ( g_hCommand == NULL ) )
	{
		/* previous result pending? */
		wchar_t * oldresult = ( wchar_t * ) GetEventData ( g_hResultEvent );
		if ( oldresult )
		{
			free ( oldresult );
		}
		SetEventData ( g_hResultEvent, 0 );
		ResetEvent ( g_hResultEvent );
		/* exec */
		FARPROC call = GetProcAddress ( g_hRilDLL, L"RIL_SendSupServiceData" );
		g_hCommand = ( ( HRESULT ( * ) ( HANDLE hRil, void *, DWORD dwSize ) ) call ) ( g_hRil, request, wcslen ( request ) * sizeof ( wchar_t ) );
		if ( SUCCEEDED ( g_hCommand ) )
		{
			/* wait for new result */
			if ( WaitForSingleObject ( g_hResultEvent, 1000 * timeout ) == WAIT_OBJECT_0 )
			{
				RILSUPSERVICEDATA * result = ( RILSUPSERVICEDATA * ) GetEventData ( g_hResultEvent );
				if ( result )
				{
					if ( result->dwParams & RIL_PARAM_SSDI_DATA )
					{
						ret = 1;
						/* */
						wcsncpy ( reply, ( wchar_t * ) result->pbData, max_reply );
						reply[max_reply - 1] = 0;
					}
					free ( result );
					SetEventData ( g_hResultEvent, 0 );
				}
			}
		}
		g_hCommand = NULL;
	}
	/* */
	return ret;
}

void ic_RIL_Free ( )
{
	if ( g_hCommand )
	{
		g_hCommand = NULL;
	}
	if ( g_hResultEvent )
	{
		/* result pending? */
		wchar_t * result = ( wchar_t * ) GetEventData ( g_hResultEvent );
		if ( result )
		{
			free ( result );
		}
		CloseHandle ( g_hResultEvent );
		g_hResultEvent = NULL;
	}
	if ( g_hRil && g_hRilDLL )
	{
		FARPROC call = GetProcAddress ( g_hRilDLL, L"RIL_Deinitialize" );
		if ( call ) ( ( HRESULT ( * ) ( HANDLE ) ) call ) ( g_hRil );
		g_hRil = NULL;
	}
	if ( g_hRilDLL )
	{
		FreeLibrary ( g_hRilDLL );
	}
}

/* PHONE MACROFUNCTIONS */
bool ic_RIL_Request_Balance ( double * balance, wchar_t * channel = NULL, DWORD timeout = 30 )
{
	bool ret = 0;
	/* need to determine channel? */
	if ( ( NULL == channel ) || ( 0 == * channel ) )
	{
		wchar_t opercode[32];
		if ( ic_RIL_NCode ( opercode, 32 ) )
		{
			if ( 0 == wcscmp ( opercode, L"25001" ) ) /* MTS-RUS */
			{
				channel = L"*100#";
			}
			else if ( 0 == wcscmp ( opercode, L"25007" ) ) /* SMARTS */
			{
				channel = L"*123#";
			}
			else if ( 0 == wcscmp ( opercode, L"25012" ) ) /* BaikalWestCom */
			{
				channel = L"*101#";
			}

			else
			{
				channel = L"*102#";
			}
		}
	}
	/* request */
	wchar_t reply[512];
	if ( channel && ( * channel ) )
	{
		/* lock cprog */
		ic_cprog_lock ( );
		/* ask for balance */
		if ( ic_RIL_USSD ( channel, timeout, reply, 512 ) )
		{
			wchar_t * optr = NULL, * ptr = NULL;
			/* replace commas with periods */
			ptr = reply;
			while ( ptr = wcschr ( ptr, ',' ) ) * ptr = '.';

			/* search from beginning */
			ptr = reply;
			/* */
			while ( ( NULL == optr ) && ( * ptr ) )
			{
				/* find number */
				while ( ( * ptr > 0 ) && ( ( * ptr < 0x30 ) || ( * ptr > 0x39 ) ) ) ++ptr;
				/* found? */
				if ( * ptr )
				{
					/* find end, count periods */
					wchar_t * eptr = ptr + 1;
					unsigned  pcnt = 0;
					while ( ( ( * eptr >= 0x30 ) && ( * eptr <= 0x39 ) ) || ( * eptr == '.' ) )
					{
						if ( * eptr == '.' ) ++pcnt;
						++eptr;
					}
					/* maybe this is a float part? */
					if ( ( ptr > reply ) && ( * ( ptr - 1 ) == '.' ) ) { --ptr; ++pcnt; }
					/* maybe this is a negative number? */
					if ( ( ptr > reply ) && ( * ( ptr - 1 ) == '-' ) ) { --ptr; }
					/* check sanity */
					if ( eptr <= ( ptr + 9 ) )
					{
						if ( 2 == pcnt )
						{
							if ( '.' == * ( eptr - 1 ) )
							{
								optr = ptr;
							}
						}
						if ( 1 == pcnt )
						{
							optr = ptr;
						}
						else if ( 0 == pcnt )
						{
							if ( ( ( '/' == * eptr ) || ( ':' == * eptr ) ) && ( ( 0x30 <= * ( eptr + 1 ) ) && ( 0x39 >= * ( eptr + 1 ) ) ) )
							{
								/* wprintf ( L"ep1: %s\n", ptr ); */
							}
							else if ( ( ( reply + 1 ) < ptr ) && ( ( ( '/' == * ( ptr - 1 ) ) || ( ':' == * ( ptr - 1 ) ) ) && ( ( 0x30 <= * ( ptr - 2 ) ) && ( 0x39 >= * ( ptr - 2 ) ) ) ) )
							{
								/* wprintf ( L"ep2: %s\n", ptr ); */
							}
							else
							{
								optr = ptr;
							}
						}
					}
					/* sane? */
					if ( optr )
					{
						* eptr = 0;
						break;						
					}
					else
					{
						ptr = eptr;
						continue;
					}
				}
			}

			/* found? */
			if ( optr )
			{
				char fbuf[512];
				for ( size_t i = 0; i < min ( wcslen ( optr ) + 1, 511 ); ++i ) fbuf[i] = ( char ) optr[i];
				fbuf[511] = 0;
				* balance = atof ( fbuf );
				ret = 1;
			}
		}
		/* wait some time and unlock */
		Sleep ( 500 );
		ic_cprog_unlock ( );
	}
	return ret;
}
