/********************************************************************************
 *   dciBalance -- balance today plugin.                                        *
 *                                                                              * 
 *   Copyright (C) 2004-2007 dci (dev@cpp.in)                                   *
 *                                                                              *
 *   This program is free software; you can redistribute it and/or              *
 *   modify it under the terms of the GNU General Public License version 2      *
 *   as published by the Free Software Foundation.                              *
 *                                                                              *
 *   This program is distributed in the hope that it will be useful,            *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          *
 *   General Public License version 2 for more details.                         *
 *                                                                              *
 *   You should have received a copy of the GNU General Public License          *
 *   version 2 along with this library; if not, write to the Free Software      *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
 ********************************************************************************
 */


#include "timelib.h"

time_t ft_to_time ( FILETIME * ft )
{
	return ( ( time_t ) ( ( ( ( ( ( __int64 ) ft->dwHighDateTime ) << 32 ) | ft->dwLowDateTime ) / 10000000 ) - 11644473600 ) );
}

void time_to_ft ( time_t timev, FILETIME * ft )
{
	__int64 ftime = ( ( ( __int64 ) timev ) + 11644473600 ) * 10000000;
	ft->dwHighDateTime = ( DWORD ) ( ftime >> 32 );
	ft->dwLowDateTime  = ( DWORD ) ( ftime );
}

time_t st_to_time ( SYSTEMTIME * st )
{
	FILETIME ft;
	SystemTimeToFileTime ( st, &ft );
	return ft_to_time ( &ft );
}

void time_to_st ( time_t timev, SYSTEMTIME * st )
{
	FILETIME ft;
	time_to_ft ( timev, &ft );
	FileTimeToSystemTime ( &ft, st );
}

time_t get_time ( )
{
	SYSTEMTIME st;
	GetLocalTime ( &st );
	return st_to_time ( &st );
}
